package logic;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;

public class SpecialCollection implements Serializable {
	private static final long serialVersionUID = 1L;
	private ArrayList<Special> specials;
	private static SpecialCollection instance;
	
	/**
	 * the instance gives a new SpecialCollection every Time it is
	 * used so every special has its own value
	 * @return
	 */
	public static SpecialCollection getInstance() {
		instance=new SpecialCollection();
		return instance;
	}
	
	/**
	 * constructs a new SpecialCollection with weights of
	 * the specials so that knowledge is more supported
	 */
	public SpecialCollection(){
		this.specials = addAllSpells();
//		Combat factor 1
		this.specials.add(new Special("scha objk", "Belagerungswaffen"));
		this.specials.add(new Special("eign objk heil tele", "Dolche"));
		this.specials.add(new Special("eign anti objk", "Fechtwaffen"));
		this.specials.add(new Special("scha", "Hiebwaffen"));
		this.specials.add(new Special("eign elemFeuer", "Raufen"));
		this.specials.add(new Special("eign elemErz", "Ringen"));
		this.specials.add(new Special("elem", "Sbel"));
		this.specials.add(new Special("eign objk elemErz elemFeuer elem form", "Stbe"));
		this.specials.add(new Special("tele eign", "Wurfmesser"));
//		Body factor 1
		this.specials.add(new Special("elemLuft eign illu", "Akrobatik"));
		this.specials.add(new Special("eign elemLuft elemWasser umwt", "Athletik"));
		this.specials.add(new Special("elemLuft", "Fliegen"));
		this.specials.add(new Special("eign illu", "Gaukeleien"));
		this.specials.add(new Special("umwt eign elemErz", "Klettern"));
		this.specials.add(new Special("eign", "Schleichen"));
		this.specials.add(new Special("elemWasser", "Schwimmen"));
		this.specials.add(new Special("elem besw krft geis anti temp herr umwt", "Selbstbeherrschung"));
		this.specials.add(new Special("elemLuft illu", "Singen"));
		this.specials.add(new Special("hell tele", "Sinnenschrfe"));
		this.specials.add(new Special("illu", "Stimmen Imitieren"));
		this.specials.add(new Special("besw herb", "Tanzen"));
		this.specials.add(new Special("elemWasser", "Zechen"));
//		Society factor 2
		ArrayList<Special> society = new ArrayList<Special>();
		society.add(new Special("einf illu", "Betren"));
		society.add(new Special("herr einf hell", "Etikette"));
		society.add(new Special("herr", "Gassenwissen"));
		society.add(new Special("einf herr illu scha", "Menschenkenntnis"));
		society.add(new Special("einf herr", "berreden"));
		society.add(new Special("herr", "berzeugen"));
		this.specials.addAll(society);
		this.specials.addAll(society);
//		Wilderness factor 1
		this.specials.add(new Special("umwt hell vers", "Fhrtensuchen"));
		this.specials.add(new Special("eign tele", "Fesseln/Entfesseln"));
		this.specials.add(new Special("umwt elemWasser", "Fischen/Angeln"));
		this.specials.add(new Special("umwt elemLuft", "Orientierung"));
		this.specials.add(new Special("elem", "Wettervorhersage"));
		this.specials.add(new Special("umwt", "Wildnisleben"));
//		Knowledge factor 3
		ArrayList<Special> knowledge = new ArrayList<Special>();
		knowledge.add(new Special("heil scha hell form", "Anatomie"));
		knowledge.add(new Special("scha elemErz umwt tele", "Baukunst"));
		knowledge.add(new Special("tele illu", "Brettspiel"));
		knowledge.add(new Special("umwt objk elem einf herr illu heil form tele anti vers herb besw scha krft geis hell elemEis", "Geographie"));
		knowledge.add(new Special("umwt objk elem einf herr illu heil form tele anti vers herb besw scha krft geis hell", "Geschichtswissen"));
		knowledge.add(new Special("elemErz objk meta krft", "Gesteinskunde"));
		knowledge.add(new Special("elem umwt anti herb dmo besw geis", "Gtter/Kulte"));
		knowledge.add(new Special("objk elemErz", "Httenkunde"));
		knowledge.add(new Special("scha", "Kriegskunst"));
		knowledge.add(new Special("meta, dmo vers hell", "Kryptographie"));
		knowledge.add(new Special("elem meta anti herb besw krft hell", "Magiekunde"));
		knowledge.add(new Special("objk", "Mechanik"));
		knowledge.add(new Special("elem umwt herr meta anti herb besw krft", "Philosophie"));
		knowledge.add(new Special("objk", "Rechnen"));
		knowledge.add(new Special("elem besw dmo anti", "Rechtskunde"));
		knowledge.add(new Special("elem dmo", "Sagen/Legenden"));
		knowledge.add(new Special("objk", "Schtzen"));
		knowledge.add(new Special("elemWasser", "Schiffbau"));
		knowledge.add(new Special("herr", "Staatskunst"));
		knowledge.add(new Special("besw herb", "Sternkunde"));
		knowledge.add(new Special("heil scha", "Tierkunde"));
		this.specials.addAll(knowledge);
		this.specials.addAll(knowledge);
		this.specials.addAll(knowledge);
//		Forgery factor 2
		ArrayList<Special> forgery = new ArrayList<Special>();
		forgery.add(new Special("herr", "Abrichten"));
		forgery.add(new Special("krft meta dmo umwt", "Alchimie"));
		forgery.add(new Special("objk", "Bergbau"));
		forgery.add(new Special("elemWasser", "Boote Fahren"));
		forgery.add(new Special("elemEis", "Eissegler fahren"));
		forgery.add(new Special("illu einf", "Falschspiel"));
		forgery.add(new Special("objk tele scha", "Feinmechanik"));
		forgery.add(new Special("elemErz", "Glaskunst"));
		forgery.add(new Special("objk elemErz scha", "Grobschmied"));
		forgery.add(new Special("herr", "Handel"));
		forgery.add(new Special("geis hell", "Hauswirtschaft"));
		forgery.add(new Special("heil form", "Heilkunde Gift"));
		forgery.add(new Special("heil form", "Heilkunde Wunden"));
		forgery.add(new Special("heil einf herr", "Heilkunde Seele"));
		forgery.add(new Special("heil form eign", "Heilkunde Krankheiten"));
		forgery.add(new Special("objk scha", "Holzbearbeitung"));
		forgery.add(new Special("herr dmo geis", "Kapellmeister"));
		forgery.add(new Special("umwt", "Kartographie"));
		forgery.add(new Special("elem herb dmo", "Kochen"));
		forgery.add(new Special("herb besw", "Malen/Zeichnen"));
		forgery.add(new Special("geis dmo", "Musizieren"));
		forgery.add(new Special("tele", "Schlsser knacken"));
		forgery.add(new Special("objk", "Schneidern"));
		forgery.add(new Special("scha", "Ttowieren"));
		forgery.add(new Special("objk elem form", "Tpfern"));
		forgery.add(new Special("herr", "Viehzucht"));
		forgery.add(new Special("meta krft", "Webkunst"));
		this.specials.addAll(forgery);
		this.specials.addAll(forgery);
	}
	
	/**
	 * adds all Spells to the SpecialCollection, every has a weight of 1 
	 * @return
	 */
	private ArrayList<Special> addAllSpells(){
		ArrayList<Special> specialSpells = new ArrayList<Special>();
		for (Spell spell : SpellCollection.getInstance().getSpells()){
			specialSpells.add(new Special(spell));
		}
		return specialSpells;
	}
	
	/**
	 * does exactly the sams as the getSpellsbyTag() in the
	 * SpellCollection
	 * @param count
	 * @param tokens
	 * @return
	 */
	public ArrayList<Special> getSpecialsByTag(int count, ArrayList<String> tokens){
		ArrayList<Special> founded = new ArrayList<Special>();
		for (String mytoken : tokens){
			for(Special s : this.specials){
				if(s.getGroup().contains(mytoken)){
					founded.add(s);
				}
			}
		}
		return someRandomSpecials(count, founded);
	}

	private ArrayList<Special> someRandomSpecials(int count,
			ArrayList<Special> founded) {
		ArrayList<Special> someSpecials = new ArrayList<Special>();
		int i = 0;
		while (i<count){
			someSpecials.add(founded.get(new Random().nextInt(founded.size())));
			i++;
		}
		removeDoubleValues(someSpecials);
		return someSpecials;
	}

	private void removeDoubleValues(ArrayList<Special> someSpecials) {
		Set<Special> set = new HashSet<Special>(someSpecials);
		someSpecials.clear();
		someSpecials.addAll(set);
	}
	

}
