package regions;

import java.util.*;

public class Thorwaler {
	private String firstName,lastName;
	private String firstNamesFemale = "Akja,Aelfhild,Algrid,Alvida,Andra,Anga,Anhild,Arva,Asgerda,Asgrima,Askra,Beornhild,Bera,Bjarnilda,Branda,Bridgera,Bryda,Eilifauchm,Eindara,Eldgrima,Estrid,Eyvin,Firunja,Frenja,Fridgera,Garhelt,Garhilda,Grima,Gunbritt,Gundrid,Gunda,Hallbera,Hardsgera,Helma,Hilda,Hjalfrida,Hjalka,Hjalma,Hjalda,Hjaldis,Hjalla,Hjelgira,Hjora,Hrafnhild,Ifirniane,Ifirnslinda,Ingira,Isliva,Jadra,Janda,Jurga,Karva,Katla,Kjaska,Korja,Lialin,Lingard,Liflind,Livka,Marada,Nellgard,Norhild,Odda,Olburga,Olgerda,Olverja,Ragna,Ragnild,Rangnid,Raska,Rorlifa,Salda,Sigrida,Sigrun,Solva,Solveig,Svala,Svenna,Svenja,Swafgardauchm,Swafnild,Swangard,Tjalva,Thora,Thordis,Thorfinna,Thorhalla,Torgrid,Torlind,Wulfgarda,Wulflinda,Wulfhilda,Yasma";
	private String firstNamesMale = "Aki,Ansgar,Ansir,Arngrim,Asgrimm,Askir,Asleif,Atli,Atmaskott,Beorn,Beowulf,Bjeri,Bjarni,Bjrn,Brand,Egil,Eilifauchw,Eindrin,Eirik,Eldgrimm,Faenwulf,Firunjar,Fjolnir,Frenjar,Garald,Garulf,Geir,Gerskir,Gunni,Hakon,Hallar,Halfdan,Hardger,Hardred,Hasgar,Helgi,Hjerolf,Herrn,Hjalldi,Hjore,Hjalmar,Hjaldar,Hjelm,Ingald,Ingirid,Ingibjrg,Iskir,IsIeif,Jora,Jurge,Karven,Kari,Ketil,Kjaskar,Laske,Leif,Liskolf,Maednir,Noerre,Norri,Olav,Olgard,Olgi,Olvir,Orgen,Orozar,Orm,Ragnar,Raskir,Rekki,Rngvald,Rodi,Rorleif,Runolf,Sigridur,Sigrud,Solvi,Starkad,Steinar,Stirbjrn,Swafgardauchw,Swafnan,Swafleif,Sven,Tevil,Thinmar,Thivar,Tjalf,Thorgun,Thorkar,Thorwulf,Thurbold,Thure,Tjalf,Torben,Torbrand,Tore,Torfin,Torgal,Torkil,Torlif,Torstor,Trollwulf,Tronde,Vandrad,Walkir,Wulfgrimm,Yngvar";
	
	/**
	 * Constructs a thorwaler with parentname
	 * @param girl
	 */
	public Thorwaler(boolean girl){
		if(girl){
			String[] names = this.firstNamesFemale.split(",");
			this.firstName = names[new Random().nextInt(names.length)];
		}
		else{
			String[] names = this.firstNamesMale.split(",");
			this.firstName = names[new Random().nextInt(names.length)];
		}
		this.lastName = newParent(girl);
	}

	/**
	 * Generates parent, gender is randomly chosen 
	 * @param girl is the child a girl (because of "-son" or "-dottir"
	 * @return the lastname of the thorwaler
	 */
	private String newParent(boolean girl) {
		String name;
		boolean parentGirl = false;
		if(new Random().nextInt()%2==0){
			parentGirl = true;
		}
		if(parentGirl){
			String[] names = this.firstNamesFemale.split(",");
			name = names[new Random().nextInt(names.length)];
		}
		else{
			String[] names = this.firstNamesMale.split(",");
			name = names[new Random().nextInt(names.length)];
		}
		if(girl){
			name = name+"dottir";
		}
		else{
			name = name+"son";
		}
		return name;
	}
	
	/**
	 * @return gets the Name of the thorwaler
	 */
	public String getName(){
		return this.firstName+" "+this.lastName;
	}

}
